class Jungler
  attr_accessor :domain

  IP_REGEX = /IN\s+A\s+(\d{1,3}.\d{1,3}.\d{1,3}.\d{1,3})/
  NS_REGEX = /IN\s+NS\s+([\w-]*\.+[\w-]+\.+[\w-]+\.+)/
  def initialize(domain)
    @domain = domain
  end

  def stalk
    corresponding_ip
    ns_records
    ping_status
  end

  def corresponding_ip
    packet = Net::DNS::Resolver.start(@domain)
    answer = packet.answer.join('')
    ips = answer.scan(IP_REGEX)
    ips.each do |ip|
      ip = ip.first
      puts "#{domain} is hosted on IP : #{ip}\n"
    end
    puts "-----------------------------------------"
  end

  def ns_records
    packet = Net::DNS::Resolver.start(domain, Net::DNS::NS)
    answer = packet.answer.join('')
    nss = answer.scan(NS_REGEX)
    i = 1
    nss.each do |ns|
      ns = ns.first
      puts "Name server #{i} for domain #{@domain} : #{ns}\n"
      i += 1
    end
    puts "-----------------------------------------"
  end

  def ping_status
    Net::Ping::TCP.service_check = true

    pt = Net::Ping::TCP.new(@domain)
    if pt.ping
      puts "#{@domain} is alive."
    else
      puts "#{@domain} seems to be dead or is not reachable."
    end
  end
end
